#include"new_island.h"

void NewIsland::main() {
    // f[^ǂݍ
    HakoIO::readMapFile();

    // ςłȂ`FbN
    if(Info::totalNumber >= Value::maxNumber) {
	Util::unlock();
	HakoIO::out("mainMode = 'errorIslandFull';");
	return;
    }

    // O邩`FbN
    if(strcmp(Value::islandName, "") == 0) {
	Util::unlock();
	HakoIO::out("mainMode = 'errorNoName';");
	return;
    }

    // O`FbN
    if(Util::badNameCheck(Value::islandName)) {
	Util::unlock();
	HakoIO::out("mainMode = 'errorBadName';");
	return;
    }

    // Ȍd`FbN
    if(Util::dupCheck(Value::islandName)) {
	Util::unlock();
	HakoIO::out("mainMode = 'errorDupName';");
	return;
    }

    // password̑ݔ
    if(strcmp(Value::password, "") == 0) {
	Util::unlock();
	HakoIO::out("mainMode = 'errorNoPassword';");
	return;
    }

    // mFppX[h
    if(strcmp(Value::password, Value::password2)) {
	// passwordԈႢ
	Util::unlock();
	HakoIO::out("mainMode = 'errorWrongPassword';");
	return;
    }

    // yn󂢂Ă邩̃`FbN
    int sx = Value::pointX;
    int sy = Value::pointY;
    if(Map::countNeutral(sx, sy, 0, 91) != 91) {
	// 5wbNXɒȊO̒n`
	// ꏊȂ
	Util::unlock();
	HakoIO::out("mainMode = 'errorNotEnoughArea';");
	return;
    }

    // 鎖Ɍ
    // ԍ擾
    int id = Info::nextID;
    Info::nextID++;

    // ̐𑝂₷
    Info::totalNumber++;
    int number = Info::totalNumber;

    // IuWFNg̎擾
    Island *island = &(Info::islands[number - 1]);
    strcpy(island->name, Value::islandName);
    island->id = id;
    island->centerX = sx;
    island->centerY = sy;
    island->prize = 0;
    island->monster = 0;
    island->absent = Value::initialAbsent;
    strcpy(island->comment, "(o^)");
    strcpy(island->password, Value::password);
    island->money = Value::initialMoney;
    island->food = Value::initialFood;
    
    // n`쐬
    // 5hexCɏ
    for(int i = 19; i < 91; i++) {
	Land *land = Map::getAround(sx, sy, i);
	if(land == 0) {
	    continue;
	}
	land->kind = Land::Sea;
	land->param = Land::SeaDeep;
	land->owner = 0;
    }

    // 2hex͈͂rnɏ
    for(int i = 0; i < 19; i++) {
	Land *land = Map::getAround(sx, sy, i);
	if(land == 0) {
	    continue;
	}
	land->kind = Land::Waste;
	land->param = Land::WasteNormal;
	land->owner = number;
    }

    // 4Hexɗn𑝐B
    for(int i = 0; i < 100; i++) {
	// _W
	Point p = Map::getPoint(sx, sy, Util::dice(61));
	if(p.x == -1) {
	    continue;
	}
	if(Map::countAround(p, Land::Sea, 1, 7) < 6){
	    // ɗnꍇ
	    Land *land = Map::getLand(p);
	    int kind = land->kind;
	    if(kind == Land::Waste) {
		// rn͕nɂ
		land->kind = Land::Town;
		land->param = 0;
	    } else if(land->kind == Land::Sea) {
		if(land->param == Land::SeaShoal) {
		    // 󐣂͍rnɂ
		    land->kind = Land::Waste;
		    land->param = Land::WasteNormal;
		    land->owner = number;
		} else {
		    // CȂ󐣂ɂ
		    land->param = Land::SeaShoal;
		}
	    }
	}
    }

    // X
    int count = 0;
    while(count < 3) {
	// _W
	Land *land = Map::getAround(sx, sy, Util::dice(19));
	if(land == 0) {
	    continue;
	}

	// łɐXłȂ΁AX
	if(land->kind != Land::Forest) {
	    land->kind = Land::Forest;
	    land->param = 5; // 500{
	    count++;
	}
    }

    // 
    count = 0;
    while(count < 2) {
	// _W
	Land *land = Map::getAround(sx, sy, Util::dice(19));
	if(land == 0) {
	    continue;
	}

	// XłȂ΁A
	if((land->kind != Land::Forest) &&
	   ((land->kind != Land::Town) ||
	    (land->param == 0))) {
	    land->kind = Land::Town;
	    land->param = 5; // l500l
	    count++;
	}
    }

    // R
    count = 0;
    while(count < 1) {
	// _W
	Land *land = Map::getAround(sx, sy, Util::dice(19));
	if(land == 0) {
	    continue;
	}

	// XłȂ΁AR
	if((land->kind != Land::Forest) &&
	   ((land->kind != Land::Town) ||
	    (land->param == 0))) {
	    land->kind = Land::Mountain;
	    land->param = 0; // ̌@͂Ȃ
	    count++;
	}
    }

    // n
    count = 0;
    while(count < 1) {
	// _W
	Land *land = Map::getAround(sx, sy, Util::dice(19));
	if(land == 0) {
	    continue;
	}

	// XRłȂ΁An
	if((land->kind != Land::Forest) &&
	   (land->kind != Land::Mountain) &&
	   ((land->kind != Land::Town) ||
	    (land->param == 0))) {
	    land->kind = Land::Base;
	    land->param = 0; // on0
	    count++;
	}
    }

    // R}h쐬
    Command::initialize();
    
    // vf
    Map::estimate();

    // O
    HakoIO::hisOutput(0, island->name);

    // f[^
    HakoIO::writeComFile(id);
    HakoIO::writeInfoFile();
    HakoIO::writeMapFile();

    Util::unlock();

    Info::jsOut(0);
    HakoIO::out("mainMode = 'errorNewIsland';");
//    Sight::common();
}
