#ifndef INFO_H
#define INFO_H

#include<time.h>
#include<fstream.h>

#include "value.h"
#include "hako_io.h"

class Island;

class Info {
public:
    // ʃf[^
    static int turn;
    static time_t lastTime;
    static int totalNumber;
    static int nextID;

    // ȅ
    static Island *islands;

    // lɃ\[gAyяʕωe[ȕ
    static void sortIslands(int *);

    // f[^
    static void initialize();

    // ǂݍ
    static void input(ifstream *);

    // 
    static void output(ofstream *);

    // ʏo
    static void commonOut();

    // estimateɂēol
    static void clear();

    // ̔ԍ(IDȂď)̓擾
    static Island *getIsland(int);

    // ̔ԍ(ID)̓擾
    static Island *getIslandByID(int);

    // ̔ԍ(ID)̓̏ʂ擾
    static int getOrderByID(int);

    // JavaScripto
    static void jsOut(int);
};

class Island {
public:
    // ܒ萔
    static const int PrizeTurn1 = 0x0001;
    static const int PrizeTurn2 = 0x0002;
    static const int PrizeTurn3 = 0x0004;
    static const int PrizePros1 = 0x0008;
    static const int PrizePros2 = 0x0010;
    static const int PrizePros3 = 0x0020;
    static const int PrizeDis1  = 0x0040;
    static const int PrizeDis2  = 0x0080;
    static const int PrizeDis3  = 0x0100;
    static const int PrizeWar1  = 0x0200;
    static const int PrizeWar2  = 0x0400;
    static const int PrizeWar3  = 0x0800;

    // ̑
    char name[32];     // 
    int id;            // IDԍ
    int centerX;       // SnXW
    int centerY;       // SnYW
    int prize;         // 
    int monster;       // b
    int absent;        // AJ萔
    char comment[100];  // Rg
    char password[100]; // pX[h
    int money;         // 
    int food;          // H
    int pop;           // l
    int area;          // L
    int farm;          // _K
    int factory;       // HK
    int mountain;      // ̌@K

    // rŎgl
    int shortage; // QԂ1AUv-1AłȂ0
    int target; // ƂẴ^[Qbg
    int tx, ty; // ~TC̃^[Qbg
    int command; // s
    int amount; // ~TC̐
    int amonster; // olb̐
    int boatPeople;
    int order; // 
    int prePop; // ^[Jn_ł̐l
    int boatTotal;   // 󂯓

    // ǂݍ
    void input(ifstream *);

    // 
    void output(ofstream *);

    // ԂփZbg
    void initialize();

    // estimateɂēol
    void clear();

    // rŎgpl
    void clear2();

    // JavaScripto
    void jsOut(int);

    // A
    void income();

    // 
    void getPrize(int);
    void prizeLog(int);
};

#endif
